/*
	MicroView.win Copyright 1995 }V
	oga@dgw.yz.yamagata-u.ac.jp
*/

#include	"microview.h"

#define		EVENTA	(EventOpenON	\
			|EventRedrawON	\
			|EventCloseON	\
			|EventIconifyON	\
			|EventResizeON	\
			|EventKeyON	\
			|EventUserON	\
			|EventMouseSwitchON	)
#define		EVENTB	(EventOpenON	\
			|EventRedrawON	\
			|EventCloseON	\
			|EventMouseSwitchON	)

int	GlobalCount= 0;

static
EventExecB( wp, info )
WindowID	wp;
EventInfo	*info;
{
	DrawBuf	dbuf[ 90+1 ];
	T_BUFP	*bp= HS_WindowGetClientPointer(wp);

	switch( info->option ){
	case EventOpen:
		WindowSetEventAttr( wp, EVENTB );
		return	TRUE;

	case EventRedraw: {
		int	dc= 1,
			i= info->y;
		unsigned int	y, yy;
		unsigned char	**ptr;
		DrawSetClear( dbuf, bp->backattr );
		if( i/= bp->font_z )
			i--;
		ptr= bp->lp+i;
		y= i* bp->font_z;
		yy= info->v+ y+ bp->font_z+ bp->font_z;
		for(; y< yy && i < bp->line ; y+= bp->font_z, i++ )
			DrawSetSymbol( dbuf+dc++, 0, y, (char*)*ptr++,
						bp->attr, bp->font_y );
		WindowDraw( wp, dbuf, dc );
		return	TRUE;
		}

	case EventClose:
		WindowClose( wp );
		return	TRUE;

	case EventMouseSwitch:
		if( info->LeftON )
			ClipSetOperation( wp, info, (char**)bp->lp, bp->line,
				0, 0, FALSE, bp->attr, bp->font_z );
		return	TRUE;
	}
	return	FALSE;
}

static
EventExecA( wp, info )
WindowID	wp;
EventInfo	*info;
{
	DrawBuf	dbuf[10];
	T_BUFP	*bp= HS_WindowGetClientPointer(wp);

	switch( info->option ){
	case EventOpen:
		WindowSetEventAttr( wp, EVENTA );
		return	TRUE;

	case EventRedraw: {
			int	x= HS_WindowGetViewSizeX(wp),
				y= HS_WindowGetViewSizeY(wp);
			DrawSetLine( dbuf, x-10, y-10, x, y, ColorGray,
								OptionFill );
			WindowDraw( wp, dbuf, 1 );
			WindowRedraw( bp->bwp );
			if( bp->inpwp )
				WindowRedraw( bp->inpwp );
		}
		return	TRUE;

	case EventClose:
		WindowClose( wp );
		if( bp->fbuf )
			MFREE( bp->fbuf );
		if( bp->lp )
			MFREE( bp->lp );
		free( bp );
		if( !--GlobalCount )
			WindowConnectionClose();
		return	TRUE;

	case EventMouseSwitch:
		if( bp->inpwp )
			return TRUE;
		if( info->LeftON ){
			if( info->x >= HS_WindowGetViewSizeX( wp )-10
				&& info->y >= HS_WindowGetViewSizeY( wp )-10 )
				WindowResizeOperation( wp, info );
			else
				WindowSendEvent( bp->bwp, info );
			return	TRUE;
		}
		break;
	case EventResize:
		WindowResize( bp->bwp, 0, 0, info->h, info->v );
		WindowResize( wp, info->x, info->y, info->h, info->v );
		if( bp->inpwp )
	     	 WindowMove( bp->inpwp, 0, HS_WindowGetViewSizeY( bp->bwp )-12 ); 
	    WindowRedraw( wp );
		return	TRUE;

	case EventIconify:
		IconEnt( wp, bp->fname, AttrDefault, 12 );
		return	TRUE;

	case EventUser:
		if( bp->inpwp )	return FALSE;
		switch( info->ComData ){
		case UserStrings: {
				unsigned char	**p= info->ComBuffer;
				for(; *p ; BPopen( *p++, FALSE ) );
			}
			break;
		case UserPaste:
		case UserString:
			BPopen( info->ComBuffer, FALSE );
		}
		info->ComData= -1;
		return	TRUE;
	case EventKey:
		if( bp->inpwp ){
			WindowSendEvent( bp->inpwp, info );
		}else {
			KeyExec( info, bp );
		}
		return  TRUE;
	}
	return	FALSE;
}

void
MV_Open( x, y, h, v, bp )
T_BUFP	*bp;
{
	bp->awp= WindowTitleOpen( x, y, h, v, NULL, bp->fname,
					Icon|Resize|Close|Push, EventExecA );
	bp->bwp= WindowScrollOpen( 0, 0,
					HS_WindowGetViewSizeX(bp->awp),
					HS_WindowGetViewSizeY(bp->awp),
						bp->awp,
						bp->maxcol* bp->font_x,
						bp->line*bp->font_z,
						DirectionY|DirectionX,
						16, bp->font_z*2, EventExecB );
	bp->inpwp= 0;
	bp->inputbuf[0]= '\0';
	HS_WindowGetClientPointer(bp->awp)=
	HS_WindowGetClientPointer(bp->bwp)= bp;
	WindowRedraw( bp->awp );
	GlobalCount++;
}

